<?php
/* $Id: nc_auth.class.php 4606 2011-05-09 21:41:38Z denis $ */

/**
 * class nc_auth
 * @package nc_auth
 * @category nc_auth
 */
class nc_auth {
  public $hash, $tpl;
  protected $core, $db;
  protected $settings;


  // при авторизации каптча была введена неверно
  protected $invalid_captcha;

  protected function __construct () {
  
    $this->hash =  nc_auth_hash::get_object();
    $this->core = nc_Core::get_object();
    $this->db = $this->core->db;
    $this->tpl = new nc_auth_template();

    $this->core->event->bind( $this, array("addUser" => "add_user_listen") );

  }
  
  /**
  * Instance self object method
  *
  * @return self object
  */
  public static function get_object () {
    // call as static
    static $storage;
    // check inited object
    if ( !isset($storage) ) {
      // init object
      $storage = new self();
    }    
    // return object
    return is_object($storage) ? $storage : false;
  }


  public function get_value ( $key = '') {
    if ( empty($this->settings ) ) {
      $res = $this->db->get_results("SELECT SettingsKey, Value FROM Auth_Settings", ARRAY_A);
      foreach ($res as $val) $this->settings[$val['SettingsKey']] = $val['Value'];
    }

    if ( $key ) return $this->settings[$key];

    return $this->settings;
  }

  public function set_value ( $key, $value ) {
    $this->settings[$key] = $value;
    
    $key = $this->db->escape($key);
    $value = $this->db->escape($value);

    $this->db->query("SELECT `SettingsKey` FROM `Auth_Settings` WHERE `SettingsKey` = '".$key."' ");
    if ( $this->db->num_rows ) {
      $this->db->query("UPDATE `Auth_Settings` SET `Value` = '".$value."' WHERE `SettingsKey` = '".$key."' ");
    }
    else {
      $this->db->query("INSERT INTO `Auth_Settings`(`SettingsKey`,`Value`)
                  VALUES('".$key."','".$value."') ");
    }
   
    return 0;
  }



  public function token_enabled ( ) {
    $nc_core = nc_Core::get_object();
    if ( !$nc_core->php_ext('gmp') ) return false;
    return $nc_core->get_settings('authtype_admin', 'auth') & NC_AUTHTYPE_TOKEN;
  }

  

  public function add_form () {
    $nc_core = nc_core::get_object();
    $st = new nc_Component(0, 3);
    $fields = $st = $st->get_fields();
    $res =  <<<NETCAT_ADD_FORM
".( \$nc_core->get_settings('deny_reg', 'auth') ? NETCAT_MODULE_AUTH_SELFREG_DISABLED : "
".( \$warnText ? "<div class='warnText'>\$warnText</div>" : NULL )."
<form name='adminForm' id='adminForm' enctype='multipart/form-data' method='post' action='/netcat/add.php'>
<div id='nc_moderate_form'>
  <div class='nc_clear'></div>
  <input name='admin_mode' type='hidden' value='\$admin_mode' />
  <input name='catalogue' type='hidden' value='\$catalogue' />
  <input name='cc' type='hidden' value='\$cc' />
  <input name='sub' type='hidden' value='\$sub' />
  <input name='posting' type='hidden' value='1' />
  <input name='curPos' type='hidden' value='\$curPos' />
  <div class='nc_clear'></div>
</div>

".nc_string_field("$nc_core->AUTHORIZE_BY", "id='f_Login' maxlength='255' size='50'", \$classID, 1)."
<span id='nc_auth_wait' class='nc_auth_login_check'>пожалуйста, подождите</span>
<span id='nc_auth_login_ok' class='nc_auth_login_check'>логин свободен</span>
<span id='nc_auth_login_fail' class='nc_auth_login_check'>логин занят</span>
<span id='nc_auth_login_incorrect' class='nc_auth_login_check'>логин содержит запрещенные символы</span>
<br/><br/>
NETCAT_ADD_FORM;
     

    $allow_fields = explode(',', $nc_core->get_settings('field_custom', 'auth'));
    $field_all = $nc_core->get_settings('field_all', 'auth');
    if ( !empty($fields) ) foreach ( $fields as $field ) {
      if ( $field['edit_type'] > 1 ) continue;
      if ( $field['name'] == $this->core->AUTHORIZE_BY ) continue;
      if ( !$field_all && !in_array($field['name'], $allow_fields) ) continue;
      switch ($field['type']) {
        case 1:
          $res .= "\".nc_string_field(\"".$field['name']."\", \"maxlength='255' size='50'\", \$classID, 1).\"<br />\r\n";
          break;
        case 2:
          $res .= "\".nc_int_field(\"".$field['name']."\", \"maxlength='12' size='12'\", \$classID, 1).\"<br />\r\n";
          break;
        case 3:
          $res .= "\".nc_text_field(\"".$field['name']."\", \"\", \$classID, 1).\"<br />\r\n";
          break;
        case 4:
          $res .= "\".nc_list_field(\"".$field['name']."\", \"\", \$classID, 1).\"<br />\r\n";
          break;
        case 5:
          $res .= "\".nc_bool_field(\"".$field['name']."\", \"\", \$classID, 1).\"<br />\r\n";
          break;
        case 6:
          $res .= "\".nc_file_field(\"".$field['name']."\", \"size='50'\", \$classID, 1).\"<br />\r\n";
          break;
        case 7:
          $res .= "\".nc_float_field(\"".$field['name']."\", \"maxlength='12' size='12'\", \$classID, 1).\"<br />\r\n";
          break;
        case 8:
          $res .= "\".nc_date_field(\"".$field['name']."\", \"\", \$classID, 1).\"<br />\r\n";
          break;
        case 9:
          $res .= "\".nc_related_field(\"".$field['name']."\").\"<br />\r\n";
          break;
        case 10:
          $res .= "\".nc_multilist_field(\"".$field['name']."\", \"\", \"\", \$classID, 1).\"<br />\r\n";
          break;
      }
      $res.= "<br />\r\n";
    }

    $res .= NETCAT_MODERATION_PASSWORD.":<br/><input id='Password1' name='Password1' type='password' size='25' maxlength='32' value='' />
      <span id='nc_auth_pass1_security'>надежность: </span>
      <span id='nc_auth_pass1_s1' class='nc_auth_pass1_check'>низкая</span>
      <span id='nc_auth_pass1_s2' class='nc_auth_pass1_check'>средняя</span>
      <span id='nc_auth_pass1_s3' class='nc_auth_pass1_check'>высокая</span>
      <span id='nc_auth_pass1_s4' class='nc_auth_pass1_check'>очень высокая</span>
      <span id='nc_auth_pass1_empty'>пароль не может быть пустым</span>
      <span id='nc_auth_pass_min'>пароль слишком короткий</span>
      <br/><br/>";
    $res .= NETCAT_MODERATION_PASSWORDAGAIN.":<br/><input id='Password2' name='Password2' type='password' size='25' maxlength='32' value='' />
     <span id='nc_auth_pass2_ok' class='nc_auth_pass2_check'>пароли совпадают</span>
     <span id='nc_auth_pass2_fail' class='nc_auth_pass2_check'>пароли не совпадают</span>
     <br/><br/>";

    if( $this->core->modules->get_by_keyword('captcha')  && function_exists("imagegif")) {
      $res .= "\".(!\$AUTH_USER_ID && \$current_cc['UseCaptcha'] && \$MODULE_VARS['captcha'] ? nc_captcha_formfield().\"<br/><br/>\".NETCAT_MODERATION_CAPTCHA.\" (*):<br/><input type='text' name='nc_captcha_code' size='10'><br/><br/>\" : \"\").\"\r\n";
    }

    $res .=  <<<NETCAT_ADD_FORM
".( \$nc_core->get_settings('agreed', 'auth') ? "<input type='checkbox' name='nc_agreed' id='nc_agreed' value='1' /><label for='nc_agreed'>Я принимаю условия <a href='/profile/registration/agreed/'>пользовательского соглашения</a></label><br/><br/>" : "")."
<input type='submit' />
<script type='text/javascript' src='/netcat/modules/auth/auth.js'></script>
<script type='text/javascript'>
   var nc_auth_obj = new nc_auth(".json_encode(array('check_login'=>\$nc_core->get_settings('check_login', 'auth'),
                                                     'pass_min' => intval(\$nc_core->get_settings('pass_min', 'auth')),
                                                     'check_pass'=>\$nc_core->get_settings('check_pass', 'auth'),
                                                     'check_pass2'=>\$nc_core->get_settings('check_pass2', 'auth'))).");
</script>
" )."
NETCAT_ADD_FORM;
    return $res;
  }


  



  public function pa_add ( $sum, $user_id = 0, $desc = '', $dont_log = 0 ) {
    return $this->pa_operation('+', $sum, $user_id, $desc, $dont_log);
  }


  public function pa_deduct ( $sum, $user_id = 0, $desc = '', $dont_log = 0 ) {
    return $this->pa_operation('-', $sum, $user_id, $desc, $dont_log);
  }


  public function pa_operation ( $type, $sum, $user_id, $desc, $dont_log = 0) {
    $user_id = intval($user_id);
    if ( !$user_id ) {
      global $AUTH_USER_ID;
      $user_id = $AUTH_USER_ID;
    }
    $sum = doubleval($sum);

    if ( !$sum || !$user_id || ( $type != '+' && $type != '-') ) {
      return false;
    }

    $class_id = intval($this->core->get_settings('pa_class_id', 'auth'));
    $field = $this->db->escape($this->core->get_settings('pa_field', 'auth'));
    $field = 'Account';
    $class_id = 170;
    if ( !$dont_log ) {
      $this->db->query("INSERT INTO `Message".$class_id."`
                      SET `ToUserID` = '".$user_id."',
                          `Type` = '".$type."',
                          `Sum` = '".$sum."',
                          `Created` = NOW(),
                          `Description` = '".$this->db->escape($desc)."' ");
    }
    

    $cur_sum = $this->db->get_var("SELECT `".$field."` FROM `User` WHERE `User_ID` = '".$user_id."' "); 
    $cur_sum += ( $type == '+' ? 1 : -1)*$sum;
    $this->db->query("UPDATE `User` SET `".$field."` = '".$cur_sum."' WHERE `User_ID` = '".$user_id."' ");

    return $cur_sum;
  }



  /**
   *
   * @param mixed массив с параметрами формы. Ключи массива
   * form_type - тип формы: table, v/vertical, h/horizontal
   * hide_recovery_pass - если 1, то скрыть ссылку на восстановление пароля
   * hide_register_link  - если 1, то скрыть ссылку на регистрацию
   * login_save - если 1, то не показывается checkbox "запомнить меня"
   * submit_name - текст на кнопке
   * @param <type> $template
   * @return string
   */
  public function auth_form ( $params = array(), $template = array() ) {
    global $SUB_FOLDER, $REQUESTED_FROM, $REQUEST_METHOD, $REQUEST_URI, $AUTH_USER_ID, $AUTHORIZE_BY,$current_user;

    if ( $AUTH_USER_ID ) {
      return $this->auth_form_for_authorized( $params, $template);
    }

    $ex = array('vk', 'fb', 'twitter', 'openid');

    $params['need_captcha'] = $need_captcha = $this->need_captcha();
    $params['invalid_captcha'] = $this->is_invalid_captcha();
    
    // параметры по умолчанию
    if ( !$params['submit_name'] ) $params['submit_name'] = NETCAT_MODULE_AUTH_ENTER;
    if ( !$params['form_type'] || in_array($params['form_type'], array('v','h','t')) ) $params['form_type'] = 'v';
    if ( !$params['captcha_wrong'] ) $params['captcha_wrong'] = NETCAT_MODULE_CAPTCHA_WRONG_CODE;
    if ( !$params['login_wrong'] ) $params['login_wrong'] = NETCAT_MODULE_AUTH_INCORRECT_LOGIN_OR_RASSWORD;
    if ( !$params['auth_text'] ) $params['auth_text'] = NETCAT_MODULE_AUTH_AUTHORIZATION_UPPER;
    if ( !$params['login_text'] ) $params['login_text'] = NETCAT_MODULE_AUTH_LOGIN;
    if ( !$params['reg_text'] ) $params['reg_text'] = NETCAT_MODULE_AUTH_SETUP_REGISTRATION;
    if ( !$params['pass_text'] ) $params['pass_text'] = NETCAT_MODULE_AUTH_PASSWORD;
    if ( !$params['recovery_text'] ) $params['recovery_text'] = NETCAT_MODULE_AUTH_FORGOT;

    // запрещена самостоятельная регистарция
    if ( $this->core->get_settings('deny_reg', 'auth') ) $params['hide_register_link'] = 1;

    // доступность авторизации через внешние сервисы
    foreach ( $ex as $v) {
      if ( !isset($params[$v.'_enabled'])  || $params[$v.'_enabled'] ) {
        $params[$v.'_enabled'] = nc_authEx::get_object($v)->enabled();
      }
    }

    // "запомнить меня"
    if ( !$template['login_save'] ) {
      $template['login_save'] = '';
      if ($this->core->ADMIN_AUTHTYPE == 'manual' && $this->core->AUTHORIZATION_TYPE == 'cookie' ) {
        $template['login_save'] = $this->tpl->get_login_save ();
        if ( $params['login_save'] === 'auto' ) $template['login_save'] = $this->tpl->get_login_save_hidden ();
        if ( $params['login_save'] === 'checked' ) $template['login_save'] = $this->tpl->get_login_save (1);
        if ( $params['login_save'] === 'none' ) $template['login_save'] = '';
      }
    }

    // формы авторизации по умолчанию
    if ( !$template['vk_form'] ) $template['vk_form'] = $this->tpl->get_vk();
    if ( !$template['fb_form'] ) $template['fb_form'] = $this->tpl->get_fb();
    if ( !$template['twitter_form'] ) $template['twitter_form'] = $this->tpl->get_twitter();
    if ( !$template['openid_form'] ) $template['openid_form'] = $this->tpl->get_openid();
    if ( 0 && !$template['token_form'] ) $template['token_form'] = $this->tpl->get_token();
      
    // генерация формы авторизации "по умолчанию"
    if ( !isset($template['auth_form']) ) {
      $method = 'get_auth_form_'.$params['form_type'];
      $template['auth_form'] = $this->tpl->$method($params);
    }

    // замена макропеременных
    $macro = array('form_id' => "nc_auth_form".($params['ajax'] ? "_ajax" : ""),
                   'action' => $this->core->SUB_FOLDER.$this->core->HTTP_ROOT_PATH.'modules/auth/',
                   'requested_from' =>htmlspecialchars($REQUESTED_FROM ? $REQUESTED_FROM : $REQUEST_URI, ENT_QUOTES),
                   'register_link'   => nc_auth_regform_url(0, 0),
                   'recovery_link' => $this->core->SUB_FOLDER.$this->core->HTTP_ROOT_PATH.'modules/auth/password_recovery.php',
                   'login_save' => $template['login_save'],
                   'token_form' => $template['token_form'] );
    foreach ( $ex as $v) {
      $macro[$v.'_form'] =  $params[$v.'_enabled'] ? $template[$v.'_form'] :'';
    }

    if ( $need_captcha ) $macro['captcha'] = nc_captcha_formfield();

    foreach ( $macro as $k => $v ) {
      $template['auth_form'] = str_replace('%'.$k, $v, $template['auth_form']);
    }

    return $template['auth_form'];
  }



  /**
   * Выводит ссылки "Регистрация" и "Авторизация"
   */
  public function auth_links ( $params = array(), $template = array() ) {

    global $AUTH_USER_ID;
    if ( $AUTH_USER_ID ) {
      return $this->auth_form($params, $template);
    }

    $params['ajax'] = true;

    if ( !$template['auth_link_form'] ) {
      $template['auth_link_form']  = "<div class='auth_block'><div class='nc_auth_links'><a href='".  nc_auth_regform_url(0,0)."'>".NETCAT_MODULE_AUTH_SETUP_REGISTRATION."</a>  ";
      $template['auth_link_form'] .= "<a id='nc_auth_link' href='#'>".NETCAT_MODULE_AUTH_AUTHORIZATION."</a></div></div>";
      $template['auth_link_form'] .= "<div id='nc_auth_layer' style='display:none;'>".$this->auth_form($params)."<span class='simplemodal-close'></span></div>";

      $template['auth_link_form'] .= "
  <script src='".$this->core->SUB_FOLDER.$this->core->HTTP_ROOT_PATH."require/js/jquery.simplemodal-1.3.3.min.js' type='text/javascript'></script>";
      $template['auth_link_form'] .= " <script type='text/javascript' >
        var nc_auth_ajax_obj = new nc_auth_ajax(".json_encode( array('params' => urlencode(serialize($params)), 'template' => urlencode(serialize($template)), 'postlink' =>  $this->core->SUB_FOLDER.$this->core->HTTP_ROOT_PATH.'modules/auth/ajax.php' )).");
      </script>";
    }

    return $template['auth_link_form'];
  }


  public function auth_form_for_authorized ( $params = array(), $template = array() ) {
    global $current_user, $AUTHORIZE_BY,$AUTH_USER_ID, $SUB_FOLDER, $REQUEST_URI,  $REQUEST_METHOD;
    $msg_url = nc_auth_messages_url();
    $new_msg = nc_auth_messages_new();

    if ( !isset($template['messages']) ) $template['messages'] = $this->tpl->get_messages();
    if ( !isset($template['messages_new']) ) $template['messages_new'] = $this->tpl->get_messages_new();
    if ( !isset($template['authorized']) ) $template['authorized'] = $this->tpl->get_authorized();

    $template['messages_new'] = str_replace( array('%msg_url', '%msg_new'),
                                             array($msg_url, $new_msg), $template['messages_new']);
    $messages = $new_msg ? $template['messages_new'] : $template['messages'];

    $result = str_replace(array('%login', '%profile_link', '%exit_link', '%messages'),
                          array($current_user[$AUTHORIZE_BY] ? $current_user[$AUTHORIZE_BY] : $current_user['ForumName'],
                                 nc_auth_profile_url($AUTH_USER_ID),
                                 $this->core->SUB_FOLDER.$this->core->HTTP_ROOT_PATH."modules/auth/?logoff=1&amp;REQUESTED_FROM=".$REQUEST_URI."&amp;REQUESTED_BY=".$REQUEST_METHOD,
                                 $messages),
                          $template['authorized']);

    return $result;
  }


  public function need_captcha () {
    $max_n = $this->core->get_settings('auth_captcha_num', 'auth');
    if ( !$max_n ) return false;
    $need_captcha = 0;
    if ( $_SESSION['ncAttemptAuth'] >= $max_n  ) return true;
    if ( $_COOKIE['ncAttemptAuth'] >= $max_n ) return true;

    if ( $this->core->input->fetch_get_post('AuthPhase') && ($name=$this->core->input->fetch_get_post('AUTH_USER')) ) {
      $num_a = $this->db->get_var("SELECT `ncAttemptAuth` FROM `User` WHERE `".$this->core->AUTHORIZE_BY."` = '".$this->db->escape($name)."' ");
      if ( $num_a >= $max_n ) $need_captcha = 1;
    } 
    return $need_captcha;
  }


  public function set_invalid_captcha ( ) {
    $this->invalid_captcha = true;
  }


  public function is_invalid_captcha ( ) {
    return $this->invalid_captcha;
  }



  public function add_user_listen ( $user_id ) {
    $user_id = intval($user_id);

    // личный счет
    if ( $this->core->get_settings('pa_allow', 'auth') &&
         ($start = $this->core->get_settings('pa_start', 'auth')) ) {
      $this->pa_add($start, $user_id, 'Стартовый капитал'); 
    }
    
  }


  public function get_confirm_mail ( $user_id ) {
    $userinfo = $this->db->get_row("SELECT * FROM `User` WHERE `User_ID` = '".intval($user_id)."' ", ARRAY_A);
    $subject = $this->core->get_settings('mail_confirm_subject', 'auth');
    $body = $this->core->get_settings('mail_confirm_body', 'auth');
    $is_hrml = $this->core->get_settings('mail_confirm_is_html', 'auth');

    $macro = array('SITE_NAME' => $this->core->catalogue->get_current('Catalogue_Name'),
                   'SITE_URL' => $_SERVER['HTTP_HOST'],
                   'USER_LOGIN' => $userinfo[$this->core->AUTHORIZE_BY],
                   'PASSWORD'   => $this->core->input->fetch_get_post('Password1'),
                   'CONFIRM_LINK' => "http://".$_SERVER['HTTP_HOST']."/netcat/modules/auth/confirm.php?id=".$userinfo['User_ID']."&code=".$userinfo['RegistrationCode']);

    foreach ( $macro as $k => $v ) {
      $subject = str_replace ('%'.$k, $v, $subject);
      $body = str_replace ('%'.$k, $v, $body);
    }

    return array('subject' => $subject, 'body' => $body, 'html' => $is_hrml );
  }



  public function get_recovery_mail ( $user_id,$confirm_code ) {
    global $sub;
    global $HTTP_HOST,$SUB_FOLDER,$HTTP_ROOT_PATH;

    $confirm_link = "http://".$HTTP_HOST.$SUB_FOLDER.$HTTP_ROOT_PATH."modules/auth/password_recovery.php?sub=".$sub."&uid=".$user_id."&ucc=".$confirm_code;

    $userinfo = $this->db->get_row("SELECT * FROM `User` WHERE `User_ID` = '".intval($user_id)."' ", ARRAY_A);
    $subject = $this->core->get_settings('mail_recovery_subject', 'auth');
    $body = $this->core->get_settings('mail_recovery_body', 'auth');
    $is_hrml = $this->core->get_settings('mail_recovery_is_html', 'auth');

    $macro = array('SITE_NAME' => $this->core->catalogue->get_current('Catalogue_Name'),
                   'SITE_URL' => $_SERVER['HTTP_HOST'],
                   'USER_LOGIN' => $userinfo[$this->core->AUTHORIZE_BY],
                   'CONFIRM_LINK' => $confirm_link);

    foreach ( $macro as $k => $v ) {
      $subject = str_replace ('%'.$k, $v, $subject);
      $body = str_replace ('%'.$k, $v, $body);
    }

    return array('subject' => $subject, 'body' => $body, 'html' => $is_hrml );
  }


  public function change_password_form () {
    global $nc_core, $db, $catalogue, $sub, $cc;
    global $HTTP_ROOT_PATH, $SUB_FOLDER;

    if (isset($_REQUEST['uid'])) $uid = (int)$_REQUEST['uid'];
    if (isset($_REQUEST['ucc'])) $ucc = htmlspecialchars($_REQUEST['ucc'], ENT_QUOTES);

    eval ('$result = "'.$nc_core->get_settings('change_password_form', 'auth').'";');

    return $result;
  }

  public function recovery_password_form () {
    global $nc_core, $db, $catalogue, $sub, $cc;
    global $Login, $Email;
    global $HTTP_ROOT_PATH, $SUB_FOLDER;

	  eval ('$result = "'.$nc_core->get_settings('recovery_password_form', 'auth').'";');

	  return $result;
  }


  public function login_form ( $IsReturn = 0) {
    global $nc_core;
    global $HTTP_ROOT_PATH, $AUTH_USER, $REQUEST_URI, $REQUESTED_FROM, $REQUEST_METHOD, $SUB_FOLDER;
    global $db, $catalogue, $sub, $cc, $AUTH_USER_ID, $AUTHORIZATION_TYPE, $ADMIN_AUTHTYPE, $REQUESTED_BY;

    if ($AUTH_USER_ID) return;

    if (!$REQUESTED_FROM) $REQUESTED_FROM = $REQUEST_URI;
    if (!isset($REQUESTED_BY) || isset($REQUESTED_BY) && (strtoupper($REQUESTED_BY) != 'GET' && strtoupper($REQUESTED_BY) != 'POST')) $REQUESTED_BY = $REQUEST_METHOD;

    if ( $nc_core->get_settings('user_login_form_disable', 'auth') ) return;

    $template = $nc_core->get_settings('user_login_form', 'auth');

    eval ('$result = "'.$template.'";');

    if ($IsReturn) {
      return $result;
    }

    echo $result;
  }

  public function get_sql_check_ip () {
    $ip_check_level = $this->core->get_settings('ip_check_level', 'auth');
    $ip_check_level = $ip_check_level > 0 && $ip_check_level <= 4 ? intval($ip_check_level) : 2;

    if ( $ip_check_level == 0) {
			$SqlCheckIp = '';
		}
		elseif ($ip_check_level  == 4) {
			$SqlCheckIp = ' AND s.UserIP = '.sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
		}
		else {
			$IpVal = explode('.', $_SERVER['REMOTE_ADDR'], $ip_check_level + 1);
			array_pop($IpVal);
			$IpVal = implode('.', $IpVal);
			$UserIPBegin = $IpVal.str_repeat('.0', 4-$ip_check_level);
			$UserIPEnd = $IpVal.str_repeat('.255', 4-$ip_check_level);
			$SqlCheckIp = ' AND s.UserIP >= '.sprintf("%u", ip2long($UserIPBegin)).' AND s.UserIP <= '.sprintf("%u", ip2long($UserIPEnd));
		}

    return $SqlCheckIp;
  }


}

?>
