<?php
/*$Id: nc_minishop_admin.class.php 4606 2011-05-09 21:41:38Z denis $*/

class nc_minishop_admin {
	
	protected $db, $UI_CONFIG;
	protected $MODULE_FOLDER, $MODULE_PATH, $ADMIN_TEMPLATE;
	
	protected $settings;
	
  public function __construct() {
    // system superior object
    $nc_core = nc_Core::get_object();
    
    // global variables
    global $UI_CONFIG;
    
    // global variables to internal
    $this->db = &$nc_core->db;
    $this->UI_CONFIG = $UI_CONFIG;
    $this->ADMIN_TEMPLATE = $nc_core->ADMIN_TEMPLATE;
    $this->MODULE_FOLDER = $nc_core->MODULE_FOLDER;
    $this->MODULE_PATH = str_replace($nc_core->DOCUMENT_ROOT, "", $nc_core->MODULE_FOLDER)."minishop/";
    
    $this->settings = $nc_core->get_settings('','minishop');
    //$this->create_module_settings();
    
  }

  public function get_mainsettings_url () {
    return "#module.minishop.settings";
  }

  /**
   * Показ информации о всех заказах
   * @global <type> $nc_minishop
   */
	public function info_show() {
    $db = nc_Core::get_object()->db;
    global $nc_minishop;
    $html = '';
    
    $cname = 'MinishopStatus';
    $class_id = $nc_minishop->order_class_id();
    $url = $nc_minishop->order_url();

    // возможные статусы заказов
    $res = $db->get_results("SELECT `".$cname."_ID` AS `id`, 	`".$cname."_Name` AS `name` FROM `Classificator_".$cname."` WHERE `Checked` = 1 ORDER BY `".$cname."_Priority`", ARRAY_A);
    foreach ( $res as $v ) {
      $order_status[ $v['id'] ] = $v['name'];
    }

    // выборка за текущий день
    $res = $db->get_results("SELECT COUNT(`Message_ID`) as `cnt`, `Status` FROM `Message".$class_id."` WHERE UNIX_TIMESTAMP(`Created`) > UNIX_TIMESTAMP(CURDATE()) GROUP BY `Status`", ARRAY_A);
    $stat['today'] = array();
    if ( $res ) foreach ( $res as $v ) {
      $stat['today'][ $v['Status'] ] = $v['cnt'];
    }

    // выборка за предыдущий день
    $stat['yesterday'] = array();
    $res = $db->get_results("SELECT COUNT(`Message_ID`) as `cnt`, `Status` FROM `Message".$class_id."` WHERE UNIX_TIMESTAMP(`Created`) BETWEEN UNIX_TIMESTAMP(CURDATE()-86400) and UNIX_TIMESTAMP(CURDATE()) GROUP BY `Status`", ARRAY_A);
    if ( $res ) foreach ( $res as $v ) {
      $stat['yesterday'][ $v['Status'] ] = $v['cnt'];
    }

    // выборка за текущий месяц
    $stat['month'] = array();
    $res = $db->get_results("SELECT COUNT(`Message_ID`) as `cnt`, `Status` FROM `Message".$class_id."` WHERE MONTH(`Created`) = MONTH(NOW()) AND YEAR(`Created`) = YEAR(NOW()) GROUP BY `Status`", ARRAY_A);
    if ( $res ) foreach ( $res as $v ) {
      $stat['month'][ $v['Status'] ] = $v['cnt'];
    }

    // выборка за предыдущий
    $stat['lastmonth'] = array();
    if ( date("m") == 1 ) {
      $month_where = "12";
      $year_where = "YEAR(NOW()) - 1";
    }
    else {
      $month_where = "MONTH(NOW())-1";
      $year_where = "YEAR(NOW())";
    }
    $res = $db->get_results("SELECT COUNT(`Message_ID`) as `cnt`, `Status` FROM `Message".$class_id."` WHERE MONTH(`Created`) = ".$month_where." AND YEAR(`Created`) = ".$year_where." GROUP BY `Status`", ARRAY_A);
    if ( $res ) foreach ( $res as $v ) {
      $stat['lastmonth'][ $v['Status'] ] = $v['cnt'];
    }

    // все
    $stat['total'] = array();
    $res = $db->get_results("SELECT COUNT(`Message_ID`) as `cnt`, `Status` FROM `Message".$class_id."` GROUP BY `Status`", ARRAY_A);
    if ( $res ) foreach ( $res as $v ) {
      $stat['total'][ $v['Status'] ] = $v['cnt'];
    } 

    $html.= '<fieldset><legend><b><font color="gray">'.NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_INFO_TAB_TABLENAME.'</font></b></legend>';
    $html.= '<table cellspacing="1" cellpadding="5" class="stat">';
    $html.= '<col style="width: 25%;"><col style="width: 15%;"><col style="width: 15%;"><col style="width: 15%;"><col style="width: 15%;"><col style="width: 15%;">';
    $html.= '<tbody>';
    // шапка
    $html.= '<tr><th></th>';
    foreach ( $order_status as $v) {
      $html .= '<th>'.$v.'</th>';
    }
    $html .= '<th><b>'.NETCAT_MODELE_MINISHOP_ADMIN_TEMPLATE_INFO_TAB_TOTALCOL.'</b></th></tr>';

    // каждая строка
    foreach ( $stat as $type => $v ) {
      $html.= '<tr><td class="type">'.constant("NETCAT_MODELE_MINISHOP_ADMIN_TEMPLATE_INFO_TAB_".strtoupper($type)."ROW").'</td>';
      $s = 0;
      foreach ( $order_status as $status_id => $status ) {
        $s += $stat[$type][$status_id];
        if ( $type <> 'total' || !$stat[$type][$status_id] ) {
          $html .= '<td class="info">'.($stat[$type][$status_id]+0).'</td>';
        }
        else {
          $html .= '<td class="info"><a target="_blank" href="'.$url.'?srchPat[0]='.$status_id.'"><b>'.($stat[$type][$status_id]+0).'</b></a></td>';
        }
      }
      // колонка "всего"
      if ( $type <> 'total' || !$s ) {
        $html .= '<td class="info"><b>'.($s+0).'</b></td></tr>';
      }
      else {
        $html .= '<td class="info"><a target="_blank" href="'.$url.'"><b>'.$s.'</b></td></tr>';
      }
    }
   
    $html.= '</tbody></table></fieldset>';
    
    echo $html;
	}

  public function info_save () {
    return ;
  }

  /**
   * Вкладка "Общие настройки"
   */
  public function settings_show () {
    global $UI_CONFIG;
    $UI_CONFIG->add_settings_toolbar();
    $nc_core = nc_Core::get_object();
    $payment_clft = $nc_core->db->get_var("SELECT `Classificator_ID` FROM `Classificator` WHERE `Table_Name` = 'MinishopPayment'");
    $delivery_clft = $nc_core->db->get_var("SELECT `Classificator_ID` FROM `Classificator` WHERE `Table_Name` = 'MinishopDelivery'");
    $html = '';

    $html.="<form method='post' action='admin.php' id='MainSettigsForm' style='padding:0; margin:0;'>\n".
      "<input type='hidden' name='view' value='settings' />\n".
      "<input type='hidden' name='act' value='save' />\n".
        "<fieldset>\n".
        "<legend>\n".
        "<b><font color='gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_TITLE."</font></b>\n".
        "</legend>\n".
     "<div style='margin:10px 0; _padding:0;'>
        ".  nc_admin_input(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_SHOPNAME, 'shopname', $this->settings,40)."
      </div>
      <div style='margin:10px 0; _padding:0;'>\n
        ".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_SHOP_CURRENCY."<br/>
        <input id='currency0' type='radio' name='currency' value='0' ".(!$this->settings['currency'] ? " checked='checked' " : "")." />
        <label for='currency0'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_CURRENCY_RUB."</label><br/>
        <input id='currency1' type='radio' name='currency' value='1' ".($this->settings['currency'] ? " checked='checked' " : "")." />
        <label for='currency1'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_CURRENCY_ALT."</label>, 
        ".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_CURRENCY_ALT_NAME.": <input type='text' name='currency_name' value='".$this->settings['AltCurrencyName']."' />
        </div>\n".
        "</fieldset><br/>\n".
      "<fieldset>\n".
      "<legend>\n".
        "<b><font color='gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_AUTHORIZE_ONORDER."</font></b>\n".
        "</legend>\n".
        "<div style='margin:10px 0; _padding:0;'>\n
        <input id='auth0' type='radio' name='auth' value='0' ".(!$this->settings['auth'] ? " checked='checked' " : "")." />
        <label for='auth0'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_AUTHORIZE_NO."</label><br/>
        <input id='auth1' type='radio' name='auth' value='1' ".($this->settings['auth'] == 1 ? " checked='checked' " : "")." />
        <label for='auth1'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_AUTHORIZE_OFFER."</label><br/>
        <input id='auth2' type='radio' name='auth' value='2' ".($this->settings['auth'] == 2? " checked='checked' " : "")." />
        <label for='auth2'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_AUTHORIZE_YES."</label><br/>
        </div>\n".
      "</fieldset><br/>\n".
      "</div>\n".
      "<fieldset>\n".
      "<legend>\n".
        "<b><font color='gray'>Доставка и оплата</font></b>\n".
        nc_admin_checkbox(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_DELIVERY.' (<a target="_blank" href="'.$nc_core->SUB_FOLDER.'/netcat/admin/#classificator.edit('.$delivery_clft.')">'.NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_DELIVERY_SETTINGS.'</a>)', 'delivery_allow', $this->settings['delivery_allow'] ).
        nc_admin_checkbox(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_PAYMENT.'(<a target="_blank" href="'.$nc_core->SUB_FOLDER.'/netcat/admin/#classificator.edit('.$payment_clft.')">'.NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_DELIVERY_SETTINGS.'</a>)', 'payment_allow', $this->settings['payment_allow'] ).
      "</fieldset><br/>\n".
      "<fieldset>\n".
      "<legend>\n".
        "<b><font color='gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_NOTIFY_TITLE."</font></b>\n".
        "</legend>\n".
         nc_admin_checkbox(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_NOTIFYCLIENT, 'notify', $this->settings).
         nc_admin_input(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_SHOPEMAIL. " (".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_DEFAULT_EMAIL." ".$nc_core->get_settings('SpamFromEmail').")", 'shop_email', $this->settings)."<br/>".
         nc_admin_input(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_ADMINEMAIL. " (".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_SETTINGS_TAB_DEFAULT_EMAIL." ".$nc_core->get_settings('SpamFromEmail').")", 'admin_email', $this->settings)."<br/>".
        "</fieldset><br/>\n".
      "</form>\n";

    // admin buttons
  	$UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_SAVE,
      "action" => "mainView.submitIframeForm('MainSettingsForm')"
    );
	
    echo $html;
	}
	
	public function settings_save () {
   	$nc_core = nc_core::get_object();
		$params = array('shopname', 'currency', 'currency_name', 'auth',
      'delivery_allow', 'payment_allow', 'notify',
      'shop_email', 'admin_email');
		foreach ( $params as $v ) {
      $nc_core->set_settings( $v, $nc_core->input->fetch_get_post($v), 'minishop' );
    }

    // доступ на добавление заказа
    $aid = ( $nc_core->input->fetch_get_post('auth') == nc_minishop::AUTH_REQUIRE )? 2 : 1;
    $class_id = intval($this->settings['order_class_id']);
    $nc_core->db->query("UPDATE `Sub_Class` SET `Write_Access_ID` = '".$aid."' WHERE `Class_ID` = '".$class_id."' OR `Class_Template_ID` = '".$class_id."'  ");

		$this->settings = $nc_core->get_settings('','minishop');
	}
	
	public function discount_show() {
    global $UI_CONFIG;
    $UI_CONFIG->add_settings_toolbar();
    
    $d = array();
    $d_str = $this->settings['discounts'];
    if ( $d_str) $d = unserialize ($d_str);

    echo "
      <div id='value_null' class='status_error'>Не введено значение скидки</div>
      <div id='error_from_to' class='status_error'>Не заданы ценовые границы скидки</div>
      <div id='error_range' class='status_error'>Верхняя граница скидки меньше нижней</div>
      <div id='error_overlap' class='status_error'>Некоторые скидки применяются к одному и тому же ценовому диапозону</div>
      <form method='post' action='admin.php' id='adminForm'>
      <input type='hidden' name='view' value='discount' />
      <input type='hidden' name='act' value='save' />
      ".nc_admin_checkbox(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISCOUNT_TAB_DISCOUNT_ONORDERSUM, 'discount_enabled', $this->settings)."
     <div id='all'>
       <div id='discounts'></div>
       <div><span id='add'>
         ".nc_admin_img("i_obj_add.gif", NETCAT_MODULE_SEARCH_ADMIN_ADD)." ".NETCAT_MODULE_SEARCH_ADMIN_ADD."
       </span></div>
     </div>";
    ?>
   <script type="text/javascript">
     function check_form () { // elem.css('border', '2pt solid red');
       $('.status_error').hide();
       	var params = {adminact: 'check_discount'};
        $('#adminForm').find(".val").each(function(){
          var elem = $(this);
          elem.removeClass('error_input');
          params[elem.attr("name")] = elem.val();
        });

      $.ajax({ url: '/netcat/modules/minishop/index.php',
               async: false,
               data: params,
               dataType: 'json',
               type: 'POST',
               success: function(data) {
                  if ( data.status == 'ok') {
                    document.getElementById('adminForm').submit();
                    return true;
                  }
                  var i;
                  for ( i = 0; i < data.res.length; i++) {
                    if ( data.res[i].type == 1 ) {
                      $(document.getElementById("value["+data.res[i].id+"]")).addClass('error_input');
                      $("#value_null").show();
                    }
                    if ( data.res[i].type == 2 ) {
                      $(document.getElementById("from["+data.res[i].id+"]")).addClass('error_input');
                      $(document.getElementById("to["+data.res[i].id+"]")).addClass('error_input');
                      $("#error_from_to").show();
                    }
                    if ( data.res[i].type == 3 ) {
                      $(document.getElementById("from["+data.res[i].id+"]")).addClass('error_input');
                      $(document.getElementById("to["+data.res[i].id+"]")).addClass('error_input');
                      $("#error_range").show();
                    }
                    if ( data.res[i].type == 4 ) {
                      $("#error_overlap").show();
                    }
                  }
               }
             });
     }
     $("#discount_enabled").change( function() {
      if ( $("#discount_enabled").attr('checked') ) $("#all").show();
      else {  $("#all").hide(); }
     } );
      (function(discounts) {
        var tpl = '<div class="discount index%x">' +
                  'Сумма заказа от' +
                  '<input type="text" id="from[%x]" name="from[%x]" class="from val" size="5" value="0"/>' +
                  'до' +
                  '<input type="text" id="to[%x]" name="to[%x]" class="to val" size="5" value="0"/>' +
                  ' &#8212;&nbsp; скидка ' +
                  '<input type="text" id="value[%x]" name="value[%x]" class="value val" size="3" value="0"/>' +
                  ' % ' +
                  '<span class="del">' +
                  "<?=nc_admin_img("i_delete.gif", NETCAT_MODULE_SEARCH_ADMIN_DELETE) ?>" +
                  '<span class="dellabel"> удалить </span>'
                  '</span>'
                  '</div>';
        var last = 0;


        function add (index, disc) {
          var div = $(tpl.replace(/%x/g, index));
          div.find("input.from").val(disc.from);
          div.find("input.to").val(disc.to);
          div.find("input.value").val(disc.value);
          div.find("span.del").click(function() { $(this).parent().remove(); });
          div.appendTo('#discounts');
        }

        $('#add').click(function() { add(last++, { from: 0, to: 0, value: 0} )});
        for (var i in discounts) { add(last++, discounts[i]); }

    })(<?=nc_array_json( $d) ?>);

    $("#discount_enabled").change();
    </script>
    <?php
    echo "</form>";
    $UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_SAVE,
      "action" => "document.getElementById('mainViewIframe').contentWindow.check_form()"
    );
	}
	
	public function discount_save() {
    $nc_core = nc_Core::get_object();
    $nc_core->set_settings('discount_enabled', $nc_core->input->fetch_get_post('discount_enabled'), 'minishop');
    $d = $this->make_discount();
    if ( $d['status'] == 'error' ) {
      return false;
    }
    $nc_core->set_settings('discounts', serialize($d['res']), 'minishop');
    $this->settings = $nc_core->get_settings('','minishop');
    //dump($a);
	}

  public function make_discount () {
    $nc_core = nc_Core::get_object();
    $discount = array();
    $error = array();

    $values = $nc_core->input->fetch_get_post('value');
    $froms = $nc_core->input->fetch_get_post('from');
    $toes = $nc_core->input->fetch_get_post('to');

    if ( !empty($values) ) foreach ( $values as $i => $value ) {
      $value = intval($value);
      $from = intval($froms[$i]);
      $to = intval($toes[$i]);
      $error_flag = false;
      if ( !$value ) { $error[] = array('type' => 1, 'id' => $i); $error_flag = true; }
      if ( !$from && !$to || $from < 0 || $to < 0) { $error[] = array('type' => 2, 'id' => $i); $error_flag = true; }
      if ( $from > $to) { $error[] = array('type' => 3, 'id' => $i); $error_flag = true; }
      if ( !$error_flag ) {
        foreach ( $discount as $d ) {
          $from1 = $d['from']; $to1 = $d['to'];
          if ( $from  < $from1 && $to >  $from1 || $from  < $to1 && $to >  $to1 ||
               $from1 < $from  && $to1 > $from  || $from1 < $to  && $to1 > $to   ) {
               $error[] = array('type' => 4, 'id' => $i);
               $error_flag = true;
          }
        }
      }

      if ( !$error_flag ) {
        $discount[] = array('from' => $from, 'to' => $to, 'value' => $value);
      }

    }
    

    return empty($error) ? array( 'status' => 'ok', 'res' => $discount ) : array( 'status' => 'error', 'res' => $error );
  }

	public function display_show() {
	  global $UI_CONFIG;
    $UI_CONFIG->add_settings_toolbar();
    $result = '';
	  $html = '';
	
	  $html.="<form method='post' action='admin.php' id='DisplaySettingsForm' style='padding:0; margin:0;'>\n".
	  "<input type='hidden' name='view' value='display' />\n".
	  "<input type='hidden' name='act' value='save' />\n".
	  
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CARTPUT_ACTION."</font></b>\n".
      "</legend>\n".
	  "<div style='margin:10px 0; _padding:0;'>\n".
      "<input id='ajax1' type='radio' name='ajax' value='1'".($this->settings['ajax'] ? " checked" : "")." />
      <label for='ajax1'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CARTPUT_NORELOAD."</label>
       <br/>
       <div style='padding-left: 15px;'>
         <input id='notify2' type='radio' name='notify' value='".nc_minishop::NOTIFY_DIV."' ".( $this->settings['notify'] == nc_minishop::NOTIFY_DIV ? "checked='checked'" : "")." />
         <label for='notify2'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CARTPUT_NOTIFY_DIV."</label><br/>
         <input id='notify1' type='radio' name='notify' value='".nc_minishop::NOTIFY_ALERT."' ".( $this->settings['notify'] == nc_minishop::NOTIFY_ALERT ? "checked='checked'" : "")." />
         <label for='notify1'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CARTPUT_NOTIFY_ALERT."</label><br/>
         <input id='notify0' type='radio' name='notify' value='".nc_minishop::NOTIFY_NONE."' ".( $this->settings['notify'] == nc_minishop::NOTIFY_NONE ? "checked='checked'" : "")."  />
         <label for='notify0'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CARTPUT_NOTIFY_NONE."</label><br/>
       </div>
      <input id='ajax0' type='radio' name='ajax' value='0'".( !$this->settings['ajax'] ? " checked" : "")." />
      <label for='ajax0'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CARTPUT_RELOAD."</label>".
      "</div>\n".
      "</fieldset><br/>".
      
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_PUT_BUTTON."</font></b>\n".
      "</legend>\n".
	  "<div style='margin:10px 0; _padding:0;'>\n";
    $c = array ( nc_minishop::PUT_TEXT, nc_minishop::PUT_IMG, nc_minishop::PUT_TEXTIMG, nc_minishop::PUT_BUTTON, nc_minishop::PUT_FORM );
    foreach ( $c as $v ) {
      $html .= "<input id='putbutton".$v."' type='radio' name='put_button' value='".$v."' ".( $this->settings['put_button'] == $v ? "checked='checked'" : "")." />
         <label for='putbutton".$v."'>".constant("NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_PUT_AS".$v)."</label><br/>";
    }
    $html .=
      nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_PUT_ALTERNATE." (<a href='#' onclick='gen(\"put_button_alternate\",$(\"input[name=\\\"put_button\\\"]:checked\").val());return false;'>".NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_GENERATE_TEMPLATE."</a>)", 'put_button_alternate', $this->settings, 1).
      nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_MASSPUT_ALTERNATE." (<a href='#' onclick='gen(\"mass_put_alternate\");return false;'>".NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_GENERATE_TEMPLATE."</a>)", 'mass_put_alternate', $this->settings, 1).
      "</div>\n".
      "</fieldset><br/>".
      
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ALREADY_INCART."</font></b>\n".
      "</legend>\n".
	  "<div style='margin:10px 0; _padding:0;'>\n
      <input id='already_in_cart0' type='radio' name='already_in_cart' value='0' ".( !$this->settings['already_in_cart']  ? "checked='checked'" : "")." />
      <label for='already_in_cart0'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ALREADY_ASTEXT."</label><br/>
      <input id='already_in_cart1' type='radio' name='already_in_cart' value='1' ".( $this->settings['already_in_cart']  ? "checked='checked'" : "")." />
      <label for='already_in_cart1'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ALREADY_ASIMG."</label><br/>
      ".nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ALREADY_ALTERNATE." (<a href='#' onclick='gen(\"already_in_cart_alternate\",$(\"input[name=\\\"already_in_cart\\\"]:checked\").val());return false;'>".NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_GENERATE_TEMPLATE."</a>)", 'already_in_cart_alternate', $this->settings, 1).
      "</div>\n".
      "</fieldset><br/>".
      
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CART."</font></b>\n".
      "</legend>\n".
	      "<div style='margin:10px 0; _padding:0;'>\n".
        nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CART_NONEMPTY." (<a href='#' onclick='gen(\"cart_full\");return false;'>".NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_GENERATE_TEMPLATE."</a>)", 'cart_full', $this->settings, 1).
        nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CART_EMPTY." (<a href='#' onclick='gen(\"cart_empty\");return false;'>".NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_GENERATE_TEMPLATE."</a>)", 'cart_empty', $this->settings, 1).
        nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_CART_AFTERTEXT, 'cart_after', $this->settings, 1).
        "</div>\n".
      "</fieldset><br/>".

      "<fieldset>
        <legend style='font-weight:bold; color:gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_NOTIFY."</legend>".
        nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_NOTIFY_ALERT_TEXT, 'notify_alert', $this->settings, 1).
        nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_NOTIFY_DIV_TEXT, 'notify_div', $this->settings, 1).
      "</fieldset><br/>

      <fieldset>
        <legend style='font-weight:bold; color:gray'>".NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ORDERFORM."</legend>".
        nc_admin_checkbox(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ORDERFORM_INLINE, 'orderform_inline', $this->settings).
        nc_admin_checkbox(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ORDERFORM_USECAPTCHA, 'orderform_captcha', $this->settings).
        nc_admin_textarea(NETCAT_MODULE_MINISHOP_ADMIN_TEMPLATE_DISPLAY_TAB_ORDERFORM_AFTERTEXT, 'orderfrom_text', $this->settings, 1).
      "</fieldset><br/>
	  </form>";
	
    $html .= nc_admin_js_resize();
    // admin buttons
  	$UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_SAVE,
      "action" => "mainView.submitIframeForm('DisplaySettingsForm')"
    );
	
    echo $html;
	}
	
	public function display_save() {
		$nc_core = nc_core::get_object();
		$params = array('ajax', 'notify', 
                    'put_button', 'put_button_alternate', 'mass_put_alternate',
                    'already_in_cart', 'already_in_cart_alternate',
                    'cart_full', 'cart_empty', 'cart_after',
                    'notify_alert', 'notify_div',
                    'orderform_inline','orderform_captcha', 'orderfrom_text');
		foreach ( $params as $v ) {
      $nc_core->set_settings( $v, $nc_core->input->fetch_get_post($v), 'minishop' );
    }

		$this->settings = $nc_core->get_settings('','minishop');
		return true;
	}
	
	public function mails_show() {
    global $UI_CONFIG;
    $UI_CONFIG->add_settings_toolbar();
    $this->settings = nc_Core::get_object()->get_settings('', 'minishop');
    
    $result = "<form action='admin.php' method='post' >
               <input type='hidden' name='view' value='mails' />
               <input type='hidden' name='act' value='save' /> ";

    // письмо покупателю
    $result .= "<fieldset><legend><b style='color: gray'>Письмо покупателю</b></legend>";
    $result .= nc_admin_input('Заголовок письма', 'mail_subject_customer', $this->settings,0, 'width:100%');
    $result .= nc_admin_textarea('Тело письма', 'mail_body_customer', $this->settings, 1, 0, 'height: 15em;');
    $result .= nc_admin_checkbox('HTML-письмо', 'mail_ishtml_customer', $this->settings, 1);
    $result .= "</fieldset><br/>";

    // письмо админку
    $result .= "<fieldset><legend><b style='color: gray'>Письмо менеджеру</b></legend>";
    $result .= nc_admin_input('Заголовок письма', 'mail_subject_admin', $this->settings,0, 'width:100%');
    $result .= nc_admin_textarea('Тело письма', 'mail_body_admin', $this->settings, 1, 0, 'height: 15em;');
    $result .= nc_admin_checkbox('HTML-письмо', 'mail_ishtml_admin', $this->settings, 1);
    $result .= "</fieldset><br/>";


	
    $result .= "</fieldset></form>";
    $result .= nc_admin_js_resize();


  	$UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_SAVE,
      "action" => "mainView.submitIframeForm('SettingsForm')"
    );
	
    echo $result;
	}
	
	public function mails_save() {
    $nc_core = nc_core::get_object();
		$params = array('mail_subject_customer', 'mail_body_customer', 'mail_ishtml_customer',
		                'mail_subject_admin', 'mail_body_admin', 'mail_ishtml_admin');
		foreach ( $params as $v ) {
      $nc_core->set_settings( $v, $nc_core->input->fetch_get_post($v), 'minishop' );
    }
	}

  public function system_show () {
    global $UI_CONFIG;
    $UI_CONFIG->add_settings_toolbar();
    $settings = nc_Core::get_object()->get_settings('', 'minishop');

    echo "<form  action='admin.php' method='post' >
    <input type='hidden' name='view' value='system' />
    <input type='hidden' name='act' value='save' />
    <fieldset><legend>Системные настройки</legend>
    <table id='systemSettings'>
    <tr><td>Компонент \"Корзина\":</td><td>".nc_admin_select_component('', 'cart_class_id', $settings['cart_class_id'])."</td></tr>
    <tr><td>Компонент \"Заказы\":</td><td>".nc_admin_select_component('', 'order_class_id', $settings['order_class_id'])."</td></tr>
    <tr><td>Ссылка на оформление заказа: </td>".nc_admin_input_in_text('<td>%input</td>', 'addorder_url', $settings)."</tr>
    <tr><td>Ссылка на список заказов: </td>".nc_admin_input_in_text('<td>%input</td>', 'order_url', $settings)."</tr>
    <tr><td>Ссылка на корзину: </td>".nc_admin_input_in_text('<td>%input</td>', 'cart_url', $settings)."</tr>
    <tr><td>Номер компонента в разделе с заказами: </td>".nc_admin_input_in_text('<td>%input</td>', 'order_cc', $settings)."</tr>
    <tr><td>Номер компонента в разделе с корзиной: </td>".nc_admin_input_in_text('<td>%input</td>', 'cart_cc', $settings)."</tr>
    </table>
    </fieldset></form>";
    $UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_MODULE_MINISHOP_ADMIN_SETTINGS_SAVE,
      "action" => "mainView.submitIframeForm('SettingsForm')"
    );
  }

  public function system_save() {
    $nc_core = nc_core::get_object();
		$params = array('cart_class_id', 'order_class_id', 'addorder_url','order_url','cart_url', 'order_cc', 'cart_cc' );
		foreach ( $params as $v ) {
      $nc_core->set_settings( $v, $nc_core->input->fetch_get_post($v), 'minishop' );
    }
	}
}

?>
