<?php
/* $Id: CheckUserFunctions.inc.php 4592 2011-05-06 13:10:47Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

/**
  * Получение языков доступных в системе
  * @return array Element[English.php] = English 
  */
function Language_Show() {
  global $ADMIN_FOLDER;
  if ( ($handle = opendir($ADMIN_FOLDER."lang"))) {
    $lang=array();
    while (false !== ($file = readdir($handle))) {
      if (strlen($file)>4 && !strpos($file, '_')) {
        $name=explode(".", $file);
        $lang[$file]=$name[0];
      }
    }
    closedir($handle);
    return($lang);
  } else {
    return(false);
  }
}


function  Unauthorize () {
  global $HTTP_HOST, $EDIT_DOMAIN, $AUTHORIZATION_TYPE;
  global $PHP_AUTH_USER, $PHP_AUTH_PW, $_SERVER, $PHP_AUTH_LANG, $PHP_AUTH_SID;
  global $PHPSESSID, $MODULE_VARS;
  global $db;
  
  if ( $sname = session_name() ) global $$sname;
    
  switch (true) {
    // cookie
    case $AUTHORIZATION_TYPE=='cookie':
      $EditDomainHost = substr($EDIT_DOMAIN,0,nc_strlen($EDIT_DOMAIN)-nc_strlen(strchr($EDIT_DOMAIN,"/")));
      $db->query("DELETE FROM `Session` WHERE `Session_ID` = '".$PHP_AUTH_SID."' OR `SessionTime` < '".time()."'");
      // unset back-end and front-end cookies
      $cookie_domain = $HTTP_HOST;
      setcookie ("PHP_AUTH_SID", NULL, NULL, "/", $cookie_domain);
      setcookie ("PHP_AUTH_LANG", NULL, NULL, "/", $cookie_domain);
      $cookie_domain = str_replace("www.", "", $HTTP_HOST);
      setcookie ("PHP_AUTH_SID", NULL, NULL, "/", $cookie_domain);
      setcookie ("PHP_AUTH_LANG", NULL, NULL, "/", $cookie_domain);
    break;
    // http
    case $AUTHORIZATION_TYPE=='http':
      unset($_SERVER['PHP_AUTH_USER']);
      unset($_SERVER['PHP_AUTH_PW']);
      unset($_SERVER['HTTP_AUTHORIZATION']);
    break;
    // session
    case $AUTHORIZATION_TYPE=='session':
      if ($$sname != "")
      {
        $db->query("DELETE FROM Session WHERE Session_ID = '".$$sname."' OR SessionTime < ".time());
          $$sname = $_POST['$sname'];
          $$sname = $_GET['$sname'];
      }
      unset($_SESSION['User']);
      session_destroy();
    break;
  }
}

function LoginFormHeader () {
  global $ADMIN_FOLDER, $ADMIN_TEMPLATE;
  $nc_core = nc_Core::get_object();
  $lang = $nc_core->lang->detect_lang();
  require_once($ADMIN_FOLDER."lang/".$lang.".php");
  echo "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional'>
<html>
  <head>
  <meta http-equiv='content-type' content='text/html; charset=".$nc_core->NC_CHARSET."'/>
  <link type='text/css' rel='Stylesheet' href='".$ADMIN_TEMPLATE."css/login.css'>
  <script type='text/javascript' src='".$nc_core->NC_JQUERY_PATH."'></script>
  <title>NetCat</title>
  </head>
  <body>
    <div class='top_line'>
      ".CONTROL_AUTH_HTML_CMS." <a href=\"http://www.netcat.ru\">NetCat</a>
    </div>
    <div class='content' align='center'>
  ";
}

function LoginFormFooter () {
  ?>
    </div>
    <div class='bottom_line'>
      <div>&copy; 1999&#8212;<?=date("Y")?> <a href='http://www.netcat.ru'><?=ENDHTML_NETCAT?></a></div>
    </div>
  </body>
</html>
  <?php
}


/**
  * Вывод формы авторизации пользователя
  */
function LoginForm () {
  global $REQUEST_URI, $AUTH_USER, $ADMIN_LANGUAGE, $ADMIN_TEMPLATE, $AUTH_PW;
  global $posting, $USER_LANG, $ADMIN_AUTHTYPE, $AUTHORIZATION_TYPE;
  global $SUB_FOLDER,$HTTP_ROOT_PATH;
  global $nc_personal, $nc_core;

  // иконка
  if ( !($_REQUEST['AUTH_USER'] || $_REQUEST['AUTH_PW']) ) {
    $icon = "<img src='".$ADMIN_TEMPLATE."img/i_netcat_big.gif' width='32' height='32' alt='NetCat' title='NetCat'/>";
  }
  else {
    $icon = "<img src='".$ADMIN_TEMPLATE."img/status_error.gif' width='32' height='32' alt='".CONTROL_AUTH_LOGIN_OR_PASSWORD_INCORRECT."' title='".CONTROL_AUTH_LOGIN_OR_PASSWORD_INCORRECT."'/>";
    $textinfo = CONTROL_AUTH_LOGIN_OR_PASSWORD_INCORRECT;
  }

  $m_auth = $nc_core->modules->get_by_keyword('auth'); // есть модуль ЛК
  $need_captcha = 0; // нужна ли каптча
  $login_en = 1; // доступна авторизация по логину
  $token_en  = 0; // доступна авторизация по токену
  if ( $m_auth ) {
    $nc_auth = nc_auth::get_object();
    $login_en = $nc_core->get_settings('authtype_admin', 'auth') & NC_AUTHTYPE_LOGIN;
    $token_en = $nc_auth->token_enabled();
    $nc_auth_token = new nc_auth_token();
    $nc_token_rand = $nc_auth_token->get_random_256();
    $_SESSION['nc_token_rand'] = $nc_token_rand;
    $need_captcha = $nc_auth->need_captcha();
    if ( $nc_auth->is_invalid_captcha() ) {
      $textinfo = NETCAT_MODULE_CAPTCHA_WRONG_CODE_SMALL;
    }
  }


  $lang = $nc_personal ? array('Russian.php' => 'Russian') : Language_Show();
  $sellang = $_COOKIE['PHP_AUTH_LANG'] ? $_COOKIE['PHP_AUTH_LANG'] : $ADMIN_LANGUAGE;

  // селект с языком
  $lang_select = "	<select name='NEW_AUTH_LANG' style='width:100%'>";
  foreach($lang AS $val) {
   $lang_select .= "<option value='".$val."'".($val==$sellang ? " selected" : "").">".$val."</option>\n";
  }
  $lang_select .="  </select>";

  // сохранить логин пароль
  $loginsave = '';
  if ($ADMIN_AUTHTYPE == 'manual' && $AUTHORIZATION_TYPE == 'cookie') {
    $loginsave = "<label><input type='checkbox' name='loginsave'/>&nbsp;".CONTROL_AUTH_HTML_SAVELOGIN."</label>";
  }


  ?>
  <noscript><div style="font-weight: bold;"><?=CONTROL_AUTH_JS_REQUIRED?></div></noscript>

  <?php if ($m_auth ) : ?>
  <script type='text/javascript' src='<?=$SUB_FOLDER.$HTTP_ROOT_PATH.'modules/auth/auth.js'?>'></script>
  <?php endif; ?>

  <script type='text/javascript'>
    function authCheckFields () {
      var authForm = document.getElementById('AUTH_FORM');
      var login = document.getElementById('AUTH_USER');
      var pass = document.getElementById('AUTH_PW');
      
      switch (true) {
        case (login.value == '' && pass.value == ''):
          alert('<?=CONTROL_AUTH_FIELDS_NOT_EMPTY?>');
        break;
        case (login.value == ''):
          alert('<?=CONTROL_AUTH_LOGIN_NOT_EMPTY?>');
        break;
        default:
          authForm.submit();
      }
    }
  </script>
  <form action='<?=$REQUEST_URI?>' method='post' name='AUTH_FORM' id='AUTH_FORM'>
	<input type='hidden' name='AuthPhase' value='1'>

  <table border='0' cellpadding='4' cellspacing='0' id="classical" style="display:none;">
    <tr>
      <td colspan="2" class="error">
        <?=$textinfo?>
      </td>
    </tr>
    <tr>
	    <td><?=CONTROL_AUTH_HTML_LOGIN?></td>
	    <td><input type='text' name='AUTH_USER' id='AUTH_USER' size='32' maxlength='255' value='<?=htmlspecialchars( stripcslashes($AUTH_USER), ENT_QUOTES )?>'></td>
	  </tr>
	  <tr>
	    <td><?=CONTROL_AUTH_HTML_PASSWORD?></td>
	    <td><input type='password' name='AUTH_PW' id='AUTH_PW' size='32' maxlength='255' value='<?=htmlspecialchars( stripcslashes($AUTH_PW), ENT_QUOTES )?>'></td>
	  </tr>
	  <tr>
	    <td><?=CONTROL_AUTH_HTML_LANG?></td>
	    <td><?=$lang_select?></td>
	  </tr>
    <?php if ( $need_captcha ) : ?>
    <tr>
      <td></td>
      <td class="captcha"><?=nc_captcha_formfield()?></td>
    </tr>
    <tr>
      <td><?=NETCAT_MODERATION_CAPTCHA_SMALL?></td>
      <td><input type='text' name='nc_captcha_code' size='32' maxlength='255' /></td>
    </tr>
    <?php endif; ?>
    <tr>
      <td <?php if ($loginsave) echo "rowspan='2'"; ?>><?=$icon?></td>
      <td><?=$loginsave?></td>
    </tr>
    <tr>
      <td>
        <input type='submit' value='<?=CONTROL_AUTH_HTML_AUTH?>' onclick='authCheckFields(); return false;'>
        <?php
          if ($posting && $REQUEST_URI!=$REQUESTED_FROM) {
            echo "<br/><a href='".$REQUESTED_FROM."' class='relogin'>".CONTROL_AUTH_HTML_BACK."</a>";
          }

        ?>
      </td>
	</tr>
</table>

  <!-- форма авторизация по токену -->
  <?php if ( $token_en ) : ?>
  <table border='0' cellpadding='4' cellspacing='0' id="token" style="display:none;">
    <tr>
      <td colspan="2">
        <div id='tokeninfo' class="error"></div>
      </td>
    </tr>
    <tr><td colspan="2">
      <object id='nc_token_plugin' type='application/x-rutoken' width='0' height='0'>
      </object>
      <input type='hidden' value='' id='nc_token_signature'  name='nc_token_signature'/>
    </td></tr>
    <tr>
      <td><?=CONTROL_AUTH_HTML_LOGIN?></td>
      <td><select  name='nc_token_login' id='nc_token_login'></select></td>
    </tr>
    <tr>
	    <td><?=CONTROL_AUTH_HTML_LANG?></td>
	    <td><?=$lang_select?></td>
	  </tr>
    <tr>
      <td><img src='<?=$ADMIN_TEMPLATE?>img/webtoken.gif' width='25' height='25' alt='WebToken' title='WebToken'/></td>
      <td colspan="2">
        <input type='submit' value='<?=CONTROL_AUTH_HTML_AUTH?>' onclick='nc_token_sign(); return false;'>
      </td>
    </tr>
  </table>
  <?php endif; ?>

  <table>
    <tr>
      <td class='cnt' colspan='2'><div id="menu"></div></td>
    </tr>
  </table>

	</form>
	
	<script type='text/javascript'>
    var authForm = document.getElementById('AUTH_FORM');
    // перенаправлять туда, куда пользователь хотел зайти
    authForm.action += window.location.hash;

    function show_token () {
      <?php if ( $login_en && $token_en ): ?>
        $("#menu").html("<a href='#' onclick='show_classical(); return false;'><?=NETCAT_AUTH_TYPE_LOGINPASSWORD?></a> <span><?=NETCAT_AUTH_TYPE_TOKEN?></span>");
      <?php endif; ?>

      $("#classical").hide();
      $("#token").show();
      $("#classical :input").attr('disabled', true);
      $("#token :input").removeAttr('disabled');
      $('#tokeninfo').hide();
      if ( !nc_token_obj.load() ) {
        $('#tokeninfo').html("<?=CONTROL_AUTH_USB_TOKEN_NOT_INSERTED?>");
        $('#tokeninfo').show();
      }
    }

    function show_classical () {
      <?php if ( $login_en && $token_en ): ?>
      $("#menu").html("<span><?=NETCAT_AUTH_TYPE_LOGINPASSWORD?></span> <a href='#' onclick='show_token(); return false;' ><?=NETCAT_AUTH_TYPE_TOKEN?></a>");
      <?php endif; ?>

      $("#classical").show();
      $("#token").hide();
      $("#classical :input").removeAttr('disabled');
      $("#token :input").attr('disabled', true);
    }

    <?php if ( $m_auth ) echo "nc_token_obj = new nc_auth_token ( {'randnum' : '".$nc_token_rand."'}); "; ?>

    function nc_token_sign ( ) {
      $('#tokeninfot').hide();
      err_text = { 1: "<?=CONTROL_AUTH_TOKEN_PLUGIN_DONT_INSTALL?>", 2: "<?=CONTROL_AUTH_USB_TOKEN_NOT_INSERTED?>",
                   3: "<?=CONTROL_AUTH_PIN_INCORRECT?>", 4: "<?=CONTROL_AUTH_KEYPAIR_INCORRECT?>"};

      if ( (err_num = nc_token_obj.sign()) ) {
        $('#tokeninfo').html(err_text[err_num]);
        $('#tokeninfo').show();
      }
    }
    <?= $login_en ? "show_classical();" : "show_token();"; ?>

  </script>
  <?php
}

function Refuse () {
  global $nc_core, $AUTH_TYPE, $admin_mode, $nc_auth;
 // AJAX call
  if ( $_POST["NC_HTTP_REQUEST"] || NC_ADMIN_ASK_PASSWORD===false) {
    // issue strange header (actually not RFC2616-compliant) and die
    header($_SERVER['SERVER_PROTOCOL']." 401 Authorization Required");
    exit;
  }

  switch ($nc_core->AUTHORIZATION_TYPE) {
    case 'cookie':
    case 'session':
      if (!$admin_mode) {
        if ( is_object($nc_auth) ) $nc_auth->login_form ();
      }
      else {
        LoginFormHeader();
        LoginForm ();
        LoginFormFooter();
      }
      break;

    default :
      # по дефолту авторизация 'http'
      Header ("WWW-authenticate:  basic  realm=Enter your login and password");
      Header ($_SERVER['SERVER_PROTOCOL'].' 401  Unauthorized');
      LoginFormHeader();
      print CONTROL_AUTH_MSG_MUSTAUTH;
      LoginFormFooter();
  }
  
  exit;
}




/**
 * Функция для авторизации
 *
 * @param int $required_id = 0, если не равен 0, то выполнится авторизация пользователя с id  = required_id
 * @param str фаза авторизации: attempt - попытка продлить авторизацию, authorize - авторизация
 * @param str вариант авторизации: NC_AUTHTYPE_LOGIN, NC_AUTHTYPE_HASH, ...
 * @param bool - авторизация в админку
 * @param bool создавать сессию
 * 
 * @return int  идентификатор авторизированного пользователя
 */
function Authorize ($required_id = 0, $auth_phase = 'attempt', $auth_variant = NC_AUTHTYPE_LOGIN, $isInsideAdmin = 0, $create_session = 1) {
	global $nc_core, $perm, $AUTH_USER_ID, $AuthPhase ;

  if ( is_object($perm) ) return $AUTH_USER_ID;

  if ( $required_id  ) {
    return $nc_core->user->authorize_by_id($required_id, $auth_variant, $isInsideAdmin, $create_session);
  }

  if ( $AuthPhase || $auth_phase == 'authorize' ) {
    global $AUTH_USER, $AUTH_PW;
    return $nc_core->user->authorize_by_pass ( $AUTH_USER, $AUTH_PW);
  }

  return $nc_core->user->attempt_to_authorize();

}



function CheckUserRights ($SubClassID, $action, $posting) {
  global $db;
  global $perm;
  # значения action
  #   1 - read
  #   2 - add
  #   4 - change
  #   8 - subscribe
  #  16 - moderate

  if (!$perm) Authorize();
  if (!is_object($perm)) return 0;
 
  if ( $perm->isSupervisor() ) {
      return 1;
  }


  switch ($action) {
    case "read":
      $mask = MASK_READ | MASK_MODERATE; //moderator can read all
      break;
    case "comment":
      $mask = MASK_COMMENT;
      break;
    case "add":
      $mask = MASK_ADD; 
      break;
    case "change":
      global $delete, $checked; // нужно точно узнать, какое изменение происходит  
      $mask =  MASK_MODERATE; // в любом случае модератор может все
      switch (true) {
        case isset($delete):
          $mask |= MASK_DELETE;
          break;
        case isset($checked):
          $mask |= MASK_CHECKED;
          break;
        default:
        $mask |= MASK_EDIT;
      }
      break;
    case "subscribe":
      $mask = MASK_SUBSCRIBE;
      break;
    case "moderate":
      $mask = MASK_MODERATE;
      break;
    default:
      $mask = MASK_READ | MASK_MODERATE;
      break;
  }

  if ( $perm->isGuest() ) { // право гость
    //дает просматривать без записи в БД
    return ($posting == 0 || $mask == 1);
  }


  #сообственно, проверка прав
  //случай, когда в разделе есть компонент
  if ( $SubClassID)
    return $perm->isSubClass ($SubClassID, $mask, true);
  
  // Возможен случай, когда в разделе нет компонента, в этом случае надо проеврить
  // на доступ к разделу.  
  global $current_sub;
  return $perm->isSubdivision($current_sub['Subdivision_ID'], $mask);
   
}



?>
