<?php
/* $Id: index.php 4599 2011-05-06 15:21:46Z gaika $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");
require_once($INCLUDE_FOLDER."unicode.inc.php");
require_once ($ROOT_FOLDER.'connect_io.php');

$catalogue = isset($catalogue) ? intval($catalogue) : 0;
$sub = isset($sub) ? intval($sub) : 0;
$cc = isset($cc) ? intval($cc) : 0;
$classID = isset($classID) ? intval($classID) : 0;
$template = isset($template) ? intval($template) : 0;
$classPreview = isset($classPreview) ? intval($classPreview) : 0;
$templatePreview = isset($templatePreview) ? intval($templatePreview) : 0;
$is_there_any_files = 0;
$message = is_array($message) ? array_map('intval', $message) : intval($message);


// parse url
$nc_core->url->parse_url();

if ($templatePreview > 0) {
  require_once($INCLUDE_FOLDER."preview/templatePreview.php");
}

if ($classPreview > 0) {
    $file_action = array('index' => 'classPreview', 'add' => 'addPreview',
                         'change' => 'messagePreview', 'search' => 'searchPreview');
    require_once($INCLUDE_FOLDER."preview/".$file_action[$action].".php");
    unset($file_action);
}


if ( strstr( $nc_core->url->get_parsed_url('path'), $nc_core->SUB_FOLDER.$nc_core->HTTP_ROOT_PATH."modules/") ) {
  $posting = true;
}

// режим netcat-admin: редактирование объектов
$inside_admin = $nc_core->inside_admin = ( !$passed_thru_404 && $nc_core->input->fetch_get_post('inside_admin') );


if ($nc_core->inside_admin) {
  // в режиме netcat-admin (список объектов) передается только $cc
  if ( $cc && !($sub || $catalogue) ) {
    $cc_data = $nc_core->sub_class->get_by_id($cc);
    $catalogue = $cc_data["Catalogue_ID"];
    $sub = $cc_data["Subdivision_ID"];
    unset($cc_data);
  }
  // при редактировании объекта передается только classID, message
  if (!$cc && $classID && $message) {
    list($catalogue, $sub, $cc) = $db->get_row("SELECT s.`Catalogue_ID`, m.`Subdivision_ID`, m.`Sub_Class_ID`
      FROM `Message".intval($classID)."` as m, `Subdivision` as s
      WHERE m.`Message_ID` = '".intval($message)."'
      AND m.`Subdivision_ID` = s.`Subdivision_ID`", ARRAY_N);
    
  }
}


// set admin mode
switch (true) {
  case ($classPreview || $templatePreview):
    $nc_core->admin_mode = false;
    break;
  case $nc_core->inside_admin:
    $nc_core->admin_mode = true;
  break;
  case !$passed_thru_404 && isset($posting): // add (edit) action
    $nc_core->admin_mode = $admin_mode;
  break;
  case !$passed_thru_404: //front-office
    $nc_core->admin_mode = true;
  break;
  case $passed_thru_404:
    $nc_core->admin_mode = false;
  break;
  default:
    $nc_core->admin_mode = false;
}
// old value
$admin_mode = $nc_core->admin_mode;

$nc_core->load_env( $catalogue, $sub, $cc);
$MODULE_VARS = $nc_core->modules->load_env();

// глобальные переменные
$admin_url_prefix = $nc_core->SUB_FOLDER.$nc_core->HTTP_ROOT_PATH;
$current_catalogue = $nc_core->catalogue->get_current();
$catalogue = $nc_core->catalogue->get_current("Catalogue_ID");
$current_sub = $nc_core->subdivision->get_current();
$sub = $nc_core->subdivision->get_current("Subdivision_ID");
$current_cc = $nc_core->sub_class->get_current();
$cc = $nc_core->sub_class->get_current("Sub_Class_ID");
$parent_sub_tree = $nc_core->subdivision->get_parent_tree($sub);
$sub_level_count = $nc_core->subdivision->get_level_count($sub);
// get system settings for compatibillity
$system_env = $nc_core->get_settings();

$operation_array = "";
// simple cc variables
if ($cc) {
  $operation_array = "current_cc";
  $moderationID = $current_cc["Moderation_ID"];
  $classID = $current_cc["Class_ID"];
  $DeleteTemplate = $current_cc["DeleteTemplate"];
  $DeleteCond = $current_cc["DeleteCond"];
}
// user mode variables
if ($user_table_mode) {
  $systemTableID = $current_cc["System_Table_ID"];
}
// general user & cc variables
if ($cc || $user_table_mode) {
  $allowTags = $current_cc["AllowTags"];
  $titleTemplate = $current_cc["TitleTemplate"];
  $addTemplate = $current_cc["AddTemplate"];
  $addCond = $current_cc["AddCond"];
  $addActionTemplate = $current_cc["AddActionTemplate"];
  $editTemplate = $current_cc["EditTemplate"];
  $editCond = $current_cc["EditCond"];
  $editActionTemplate = $current_cc["EditActionTemplate"];
  $CheckActionTemplate = $current_cc["CheckActionTemplate"];
  $DeleteActionTemplate = $current_cc["DeleteActionTemplate"];
  $searchTemplate = $current_cc["SearchTemplate"];
  $subscribeCond = $current_cc["SubscribeCond"];
  $subscribeTemplate = $current_cc["SubscribeTemplate"];
}

/*
if ( $nc_core->modules->get_by_keyword('auth')  ) {
  $nc_auth = nc_auth::get_object(); 
  AttemptToAuthorize();
}
elseif ($PHP_AUTH_USER) {
  Authorize();
}*/
$nc_core->user->attempt_to_authorize();


if ( !$AUTH_USER_ID && $nc_core->modules->get_by_keyword('auth')  && ($auth_hash = $nc_core->input->fetch_get_post('auth_hash')) ) {
  $nc_auth->hash->authorize_by_hash($auth_hash);
}

$check_auth = s_auth($current_cc, $action, isset($posting) ? $posting : 0);

$AUTH_USER_ID += 0;
$AUTH_USER_GROUP += 0;

if ($AUTH_USER_ID) {

  if (!$current_user) {
    $current_user = $db->get_row("SELECT `Language` FROM `User` WHERE `User_ID` = '".$AUTH_USER_ID."'", ARRAY_A);
  }

  $AUTH_LANG  = $current_user['Language'];

  $cookie_domain = ($nc_core->modules->get_vars('auth', 'COOKIES_WITH_SUBDOMAIN') ? str_replace("www.", "", $nc_core->HTTP_HOST) : NULL);
}

try {
  require_once ($nc_core->ADMIN_FOLDER."lang/".$nc_core->lang->detect_lang().".php");
}
catch ( Exception $e ) {
  die( $e->getMessage());
}

if( $nc_core->modules->get_vars('netshop') ) {
  // session for NetShop
  $netshop_sid = session_name();
  if ($GLOBALS[$netshop_sid]) session_id($GLOBALS[$netshop_sid]);
  // init shop object
  if ( $nc_core->modules->get_vars('netshop') ) $GLOBALS['shop'] = new NetShop();
} 

// set template from current subdivision
if (!$template) $template = $nc_core->subdivision->get_current("Template_ID");

// set template as default
if ($template) {
  $nc_core->template->set_current_by_id($template);
}

// init log functional in stats module
if ( $nc_core->modules->get_vars('stats') ) stats_Log();

if ($nc_core->inside_admin) {
  if ( $nc_core->get_settings('EditDesignTemplateID') && !$nc_core->subdivision->get_current('UseEditDesignTemplate') ) {
    $template = $nc_core->get_settings('EditDesignTemplateID');
    // set template as current
    $nc_core->template->set_current_by_id($template);
  }
  require_once ($nc_core->ADMIN_FOLDER."admin.inc.php");
  ob_start("nc_postprocess_admin_page");
}

$template_settings = array();

// get current template env
$template_env = $nc_core->template->get_current();
// %FIELD replace with inherited template field value
$template_env = $nc_core->template->convert_subvariables($template_env);
// default
$template_header = "";
$template_footer = "";

if (!$isNaked && $nc_core->get_page_type() != 'rss' && $nc_core->get_page_type() != 'xml' ) {

  $template_header = $template_env['Header'];
  $template_footer = $template_env['Footer']; 

  
  eval( $nc_core->template->get_current("Settings") );
  
  // add system CSS styles in admin mode
  if ($nc_core->get_variable("admin_mode") && !$nc_core->get_variable("inside_admin") && $template_header) {
    // addon css and js
    $template_admin_css = "<link type='text/css' rel='stylesheet' href='".$nc_core->get_variable("ADMIN_TEMPLATE")."css/admin_pages.css'/>\r\n";
    $template_admin_css .= "<script type='text/javascript' src='".$nc_core->get_variable("ADMIN_PATH")."js/package.js'></script>\r\n";
    $template_admin_css .= "<script type='text/javascript' src='".$nc_core->get_variable("ADMIN_PATH")."js/lib.js'></script>\r\n";
    $template_header = nc_insert_in_head($template_header, $template_admin_css );
  }

  // metatag noindex
  if ( $nc_core->subdivision->get_current("DisallowIndexing") == 1 ) {
    $template_header = nc_insert_in_head($template_header, "<meta name='robots' content='noindex' />" );
  }

  /*
  // JQuery
  if ( 1 && strpos($template_header, 'jquery') === false ) {
    $template_header = nc_insert_in_head($template_header, "<script type='text/javascript' src='".$nc_core->NC_JQUERY_PATH."'></script>");
  }
  */

  


  // $_GET['rand'] - подставляется в админке при просмотре страницы внутри фрейма, это нужно для снятия кэширования фрейма
  // используем этот параметр для определения отображения QuickBar
  // Если нет AUTH_USER_ID, то нужно произвести авторизацию
  if ( $nc_core->get_variable("AUTHORIZATION_TYPE") != 'http' ) {
    if ($nc_core->get_settings('QuickBar') && !isset($_GET['rand']) ) {
      $cookie_domain = ($nc_core->modules->get_vars('auth', 'COOKIES_WITH_SUBDOMAIN') ? str_replace("www.", "", $nc_core->get_variable("HTTP_HOST")) : NULL);
      if ($nc_core->input->fetch_cookie('QUICK_BAR_CLOSED')==0 || $nc_core->input->fetch_cookie('QUICK_BAR_CLOSED')==-1) {
        require_once ($nc_core->get_variable("INCLUDE_FOLDER")."quickbar.inc.php");
        $template_header = nc_quickbar_in_template_header($template_header);
        setcookie("QUICK_BAR_CLOSED", -1, time() + $nc_core->get_variable("ADMIN_AUTHTIME"), "/", $cookie_domain);
      }
      else {
        // refresh cookie expiration
        setcookie("QUICK_BAR_CLOSED", 1, time() + $nc_core->get_variable("ADMIN_AUTHTIME"), "/", $cookie_domain);
      }
    }
  }

  if ( $nc_core->template->get_current("CustomSettings") && $nc_core->subdivision->get_current('Template_ID')==$template) {
    require_once($nc_core->ADMIN_FOLDER . "array_to_form.inc.php");
    $nc_a2f = new nc_a2f( $nc_core->template->get_current("CustomSettings") );
    $nc_a2f->set_value($nc_core->subdivision->get_current("TemplateSettings"));
    $template_settings = $nc_a2f->get_values_as_array();
  }
  if ( $nc_core->template->get_current("CustomSettings") && $nc_core->subdivision->get_current('Template_ID') != $template ) {
    require_once($nc_core->ADMIN_FOLDER. "array_to_form.inc.php");
    $nc_a2f = new nc_a2f( $nc_core->template->get_current("CustomSettings"),array() );
    $template_settings = $nc_a2f->get_values_as_array();
  }
  if ($nc_core->inside_admin) {
    // output interface settings (add 'em to the footer before </body>)
    $UI_CONFIG = new ui_config_objects($cc);
    $js_code = '".$UI_CONFIG->to_json()."'; 
    if ( $template_footer && nc_preg_match("/(<\/body>)/i", $template_footer, $regs) ) { 
      $template_footer = str_replace($regs[1], $js_code.$regs[1], $template_footer);
    }
    else { 
      $template_footer .= $js_code;
    }
  }
}

if ( $nc_core->subdivision->get_current("Subdivision_ID")==$nc_core->catalogue->get_current("Title_Sub_ID") ) {
  $f_title = $nc_core->catalogue->get_current("Catalogue_Name");
}
else {
  $f_title = $nc_core->subdivision->get_current("Subdivision_Name");
}

if ( $nc_core->sub_class->get_current("Sub_Class_ID")!=$cc_array[0] && $nc_core->sub_class->get_current("Checked") ) $f_title = $nc_core->sub_class->get_current("Sub_Class_Name");

if (!$check_auth && NC_AUTH_IN_PROGRESS!==1) {

  eval("echo \"".$template_header."\";");

  if ( $AUTH_USER_ID || ( !$AUTH_USER_ID && !$nc_core->modules->get_vars('auth') ) ) {
    if ($nc_core->inside_admin) {
      nc_print_status(NETCAT_MODERATION_ERROR_NORIGHTS, 'error');
    }
    else {
      print NETCAT_MODERATION_ERROR_NORIGHTS;
    }
  }
  elseif ( !$AUTH_USER_ID && $nc_core->modules->get_vars('auth') ) {
    $nc_auth->login_form();
  }

  eval("echo \"".$template_footer."\";");
  exit;
}

if (!$message && $action=="full") exit;

if ($AUTH_USER_ID ) {
  $current_user = $nc_core->user->get_by_id($AUTH_USER_ID);
}

?>